// Lösungen zu "Richard Kaiser: C++ mit dem Borland C++Builder 2007", ISBN: 978-3-540-69575-2
// Copyright Richard Kaiser, 2007. http://www.rkaiser.de. All rights reserved.
// Diese Quelltexte dürfen in eigenen Programmen verwendet werden, wenn sie einen Hinweis auf die Quelle (die ersten beiden Zeilen) enthalten. In keinem Fall wird eine Haftung für direkte, indirekte, zufällige oder Folgeschäden übernommen, die sich aus der Nutzung ergeben.
// It is permitted to use this source text in programs of your own, provided that it contains a reference to the source (the first two lines above). All liabilities for use of the code are disclaimed.

#include <vcl.h>
#pragma hdrstop
#include "RichEdU.h"
#pragma package(smart_init)
#pragma resource "*.dfm"


//----- Aufgabe 10.5 ------------------------------------------------

TForm1 *Form1;
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
RichEdit1->ScrollBars=ssVertical;
}

void CreateRTF(TRichEdit* r)
{
r->Clear();
r->SelAttributes->Name= "Arial";
r->SelAttributes->Size=15;
r->SelAttributes->Style<<fsBold;
r->Lines->Add("Quadratzahlen\r\n");

for (int i=1;i<10;i++)
  {
    r->SelAttributes->Name= "Courier New";
    r->SelAttributes->Size=12;
    r->Lines->Add("i="+IntToStr(i)+" i*i="+IntToStr(i*i));
  }
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
CreateRTF(RichEdit1);
}


void __fastcall TForm1::ffnen1Click(TObject *Sender)
{
OpenDialog1->Filter="RTF-Dateien|*.rtf";
if (OpenDialog1->Execute())
  {
    RichEdit1->Lines->LoadFromFile(OpenDialog1->FileName);
  }
}

void __fastcall TForm1::Speichern1Click(TObject *Sender)
{
SaveDialog1->FileName="c:\\test1.rtf";
if (OpenDialog1->Execute())
  {
    RichEdit1->Lines->SaveToFile(OpenDialog1->FileName);
  }
}

void DruckenMitRichEdit()
{
TRichEdit* r=new TRichEdit(Form1);
r->Parent=Form1; // siehe Abschnitt 8.4
r->Visible=false; // RichEdit nicht sichtbar
for (int i=0; i<10; i++)
  r->Lines->Add("Line "+IntToStr(i));
r->Print("Titel des Druck-Jobs");
delete r;
}

void __fastcall TForm1::btnPrintClick(TObject *Sender)
{
DruckenMitRichEdit();
}

